function Create(self)

self.UpdateTimer = Timer()

if g_CrabBreedingTable == nil then
g_CrabBreedingTable = {}
end

self.Hunger = 0
self.HungerTimer = Timer()
self.BreedTimer = Timer()

self.Grow = 1
self.GrowTimer = Timer()

self.Gender = math.random()>0.5 --boolean

self.Scale = 1-math.random()/9

if self.Sharpness > 0 then --so we are a leetle baby, look up our genes
	local index = self.Sharpness 
	self.HungerTime = g_CrabBreedingTable[index]["hTime"]
	self.HungerAmount = g_CrabBreedingTable[index]["hAmount"]
	self.FeedAmount = g_CrabBreedingTable[index]["hFeed"]

	self.BreedTime = g_CrabBreedingTable[index]["bTime"]
	self.BreedTreshold = g_CrabBreedingTable[index]["bTreshold"]

	self.MaxGrow = g_CrabBreedingTable[index]["gLimit"]
	self.GrowTime = g_CrabBreedingTable[index]["gTime"]

	g_CrabBreedingTable[index] = nil --The length operator # returns the first non-nil index that precedes a nil.
	self.Sharpness = 0
else --not a baby
	--hunger
	self.HungerTime = math.random(10000,20000)
	self.HungerAmount = math.random(6,15)
	self.FeedAmount = math.random(15,30)
	--breeding
	self.BreedTime = math.random(40000,80000)
	self.BreedTreshold = math.random(20000,45000)
	--growing
	self.MaxGrow = math.random(3,6)
	self.GrowTime = math.random(35000,60000)
end


end


function Update(self)

if self.UpdateTimer:IsPastSimMS(500) then
self.UpdateTimer:Reset()
local part

self.AIMode = Actor.AIMODE_PATROL

	for actor in MovableMan.Actors do
		if actor.PresetName == self.PresetName and actor.ID ~= self.ID then
			if SceneMan:ShortestDistance(self.Pos,actor.Pos,SceneMan.SceneWrapsX).Magnitude<30 then
			actor.Vel = SceneMan:ShortestDistance(self.Pos,actor.Pos,SceneMan.SceneWrapsX)*0.334
			end
		end
	end


for device in MovableMan.Items do
--food
	if device.PresetName == "Crabsnack" and self.Hunger > self.FeedAmount*0.8 then
	if SceneMan:ShortestDistance(self.Pos,device.Pos,SceneMan.SceneWrapsX).Magnitude<25 and device.Vel.Magnitude < 10 then
	device.Lifetime = 1
		    	part = CreateMOSParticle("Feed Status Particle");
		    	part.Pos = self.Pos + Vector(0,-6);
		    	MovableMan:AddParticle(part);
	self.Hunger = math.max(self.Hunger-self.FeedAmount,0)
	self.Health = math.min(self.Health+math.floor(self.FeedAmount/8),100)
	self.HungerTimer:Reset()
	end
	end

end
--hunger
if self.Hunger > self.FeedAmount*1.2 then

			if math.random(100)<self.Hunger*1.2 then
		    	part = CreateMOSParticle("Hunger Status Particle");
		    	part.Pos = self.Pos + Vector(0,-6);
		    	MovableMan:AddParticle(part);
			end
		

end
--grow
if self.GrowTimer:IsPastSimMS(self.GrowTime) then
if self.Grow < self.MaxGrow then
	self.Scale = self.Scale+0.1
	part = CreateMOSParticle("Growth Status Particle");
	part.Pos = self.Pos + Vector(0,-7);
	MovableMan:AddParticle(part);
	local flesh = CreateHeldDevice("Crab Flesh")
	self:AddInventoryItem(flesh) --gold value
end
	self.GrowTimer:Reset()
end
--damage from hunger
if self.HungerTimer:IsPastSimMS(self.HungerTime) then
	self.Hunger = math.min(self.Hunger+self.HungerAmount,100)

	if self.Hunger > self.FeedAmount*1.6 then
	self.GrowTimer:Reset()
	end

	if self.Hunger > 50 then
	self.Health = self.Health-math.ceil((self.Hunger-49)/3)
	self.GrowTimer:Reset()
	end

	self.HungerTimer:Reset()

end
--not in the mood anymore
if self.BreedTimer:IsPastSimMS(self.BreedTime+self.BreedTreshold) then
self.BreedTimer:Reset()
self.Sharpness = 0
		    	part = CreateMOSParticle("Breed Exp Status Particle");
		    	part.Pos = self.Pos + Vector(0,-6);
		    	MovableMan:AddParticle(part);
end

--sexytime
if self.BreedTimer:IsPastSimMS(self.BreedTime) and not (self.Hunger > self.FeedAmount*2.2) and not (self.Health<80) then

			if math.random(5)==3 then
				if self.Gender then
		    	part = CreateMOSParticle("Breed Female Status Particle");
				else
				part = CreateMOSParticle("Breed Male Status Particle");
				end
				part.Pos = self.Pos + Vector(0,-6);
		    	MovableMan:AddParticle(part);
			end
			--give birth
			if self.Gender then
				--something poked us
				if self.Sharpness > 0 then
				if g_CrabBreedingTable[self.Sharpness] == nil then self.GibThis() return end --No hax for u
					g_CrabBreedingTable[self.Sharpness]["bTime"] = self.BreedTime
					g_CrabBreedingTable[self.Sharpness]["gLimit"] = self.MaxGrow
					g_CrabBreedingTable[self.Sharpness]["gTime"] = self.GrowTime
					local egg = CreateActor("Crab Egg")
					egg.Sharpness = self.Sharpness
					egg.Health = self.BreedTreshold/250
					egg.Pos = self.Pos
					MovableMan:AddActor(egg)

					self.BreedTimer:Reset()
					self.Sharpness = 0
					do return end
				end
			else
			--poke something
				local curdist
				local dist = 35
				local found
				for actor in MovableMan.Actors do
					if actor.PresetName == self.PresetName and actor.ID ~= self.ID then
					curdist = SceneMan:ShortestDistance(self.Pos,actor.Pos,SceneMan.SceneWrapsX).Magnitude
						if curdist<dist then
						dist = curdist
						found = actor
						end
					end
				end
				--genes!
				if MovableMan:IsActor(found) then
						local index = #g_CrabBreedingTable+1
						found.Sharpness = index
						g_CrabBreedingTable[index] = {}
						g_CrabBreedingTable[index]["hTime"] = self.HungerTime
						g_CrabBreedingTable[index]["hAmount"] = self.HungerAmount
						g_CrabBreedingTable[index]["hFeed"] = self.FeedAmount
						g_CrabBreedingTable[index]["bTreshold"] = self.BreedTreshold
						
					self.BreedTimer:Reset()
				end
			end



end

end

end
--for oogling at your eggs
--for _,t in pairs(g_CrabBreedingTable) do print(t) for k,v in pairs(t) do print(k,v) end end
--for actor in MovableMan.Actors do if actor.PresetName == "Crab Egg" then print(actor) for k,v in pairs(g_CrabBreedingTable[actor.Sharpness]) do print(k) print(v) end end end