--Nothing to see here, really


function Crabfarm:StartActivity()
   	print("START! -- Crabfarm:StartActivity()!");

		self.braindead = {};
  	-- Set up teams
   	-- Team 2 is always CPU
   	self.CPUTeam = Activity.TEAM_2;
    
   	--------------------------
    	-- Set up players
    
    	for player = 0, self.PlayerCount - 1 do
       		-- Check if we already have a brain assigned
        	if not self:GetPlayerBrain(player) then
			self.braindead[player] = false;
            		local foundBrain = MovableMan:GetUnassignedBrain(self:GetTeamOfPlayer(player));

            		-- If we can't find an unassigned brain in the scene to give each player, then force to go into editing mode to place one
            		if not foundBrain then
                		self.ActivityState = Activity.EDITING;
                		AudioMan:ClearMusicQueue();
                		AudioMan:PlayMusic("Base.rte/Music/dBSoundworks/ccambient4.ogg", -1, -1);
            		else
                		-- Set the found brain to be the selected actor at start
                		self:SetPlayerBrain(foundBrain, player);
                		self:SetViewState(Activity.ACTORSELECT, player);
                		-- Set the observation target to the brain, so that if/when it dies, the view flies to it in observation mode
                		self:SetObservationTarget(self:GetPlayerBrain(player).Pos, player)
            		end
        	end
    	end
end
---------------------------------------------------------------------------------------

function Crabfarm:PauseActivity(pause)
    print("PAUSE! -- Crabfarm:PauseActivity()!");
end
-------------------------------------------------------------------------------------

function Crabfarm:EndActivity()
    print("END! -- Crabfarm:EndActivity()!");
end

function Crabfarm:EndActivity()
   --------------------------
    -- Iterate through all human players

    for player = 0, self.PlayerCount - 1 do
        -- The current player's team
        local team = self:GetTeamOfPlayer(player);
        
        -- Make sure the game is not already ending
        if not (self.ActivityState == Activity.OVER) then
            -- Check if any player's brain is dead
            local brain = self:GetPlayerBrain(player);
            if not brain or not MovableMan:IsActor(brain) or not brain:HasObjectInGroup("Brains") then
                self:SetPlayerBrain(nil, player);
                -- Try to find a new unasigned brain this player can use instead, or if his old brain entered a craft
                local newBrain = MovableMan:GetUnassignedBrain(team);
                -- Found new brain actor, assign it and keep on truckin'
                if newBrain and self.braindead[player] == false then
                    self:SetPlayerBrain(newBrain, player);
		    if MovableMan:IsActor(newBrain) then
                        self:SwitchToActor(newBrain, player, team);
		    end
                else                
                    FrameMan:SetScreenText("Your brain has been lost!", player, 333, -1, false);
		    self.braindead[player] = true;
                    -- Now see if all brains of self player's team are dead, and if so, end the game
                    if not MovableMan:GetClosestBrainActor(team) then
                        self.WinnerTeam = self:OtherTeam(team);
                        ActivityMan:EndActivity();
                    end
                    self:ResetMessageTimer(player);
                end
            else
                -- Update the observation target to the brain, so that if/when it dies, the view flies to it in observation mode
                self:SetObservationTarget(brain.Pos, player)
            end
        -- Game over, show the appropriate messages until a certain time
        elseif not self.GameOverTimer:IsPastSimMS(self.GameOverPeriod) then
-- TODO: make more appropriate messages here for run out of funds endings
            if team == self.WinnerTeam then
                FrameMan:SetScreenText("what did you even do?", player, 0, -1, false);
            else
                FrameMan:SetScreenText("Your brain has been lost!", player, 0, -1, false);
            end
        end
    end
end